# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ContainerRegistry::Mgmt::V2019_05_01_preview
  module Models
    #
    # The parameters used to generate credentials for a specified token or user
    # of a container registry.
    #
    class GenerateCredentialsParameters

      include MsRestAzure

      # @return [String] The resource ID of the token for which credentials
      # have to be generated.
      attr_accessor :token_id

      # @return [DateTime] The expiry date of the generated credentials after
      # which the credentials become invalid. Default value:
      # Date.parse('9999-12-31T15:59:59.9999999-08:00') .
      attr_accessor :expiry

      # @return [TokenPasswordName] Specifies name of the password which should
      # be regenerated if any -- password or password2. Possible values
      # include: 'password1', 'password2'
      attr_accessor :name


      #
      # Mapper for GenerateCredentialsParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'GenerateCredentialsParameters',
          type: {
            name: 'Composite',
            class_name: 'GenerateCredentialsParameters',
            model_properties: {
              token_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tokenId',
                type: {
                  name: 'String'
                }
              },
              expiry: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expiry',
                default_value: Date.parse('9999-12-31T15:59:59.9999999-08:00'),
                type: {
                  name: 'DateTime'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
